/**
 * © 2008 by David Roden <droden@gmail.com>
 */

#pragma once

#include "ReaderInput.h"
#include "ED2KLink.h"
#include "GrowingBuffer.h"

class CollectionReader {

public:
	CollectionReader(ReaderInput* readerInput);
	~CollectionReader();

	ED2KLink* getNextLink();

private:
	void identifyCollectionType();
	bool isLineBreakPresent();
	bool ensureBufferCapacity(size_t byteCount);
	void readMoreBytes();

private:
	ReaderInput* readerInput;
	GrowingBuffer growingBuffer;
	int version;
	bool firstLink;
	bool isTextCollection;

};

